﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;

namespace BdDemo
{
    public class HttpHelp
    {
        private CookieCollection _cookiecollection = new CookieCollection();
        public CookieCollection CookieCollection                                  //这里保存的是cookie，BAIDUID从这里找出来              
        {
            get { return this._cookiecollection; }
            set { this._cookiecollection = value; }
        }

        private CookieContainer _cookiecontainer = new CookieContainer();
        public CookieContainer CookieContainer
        {
            get { return this._cookiecontainer; }
            set { this._cookiecontainer = value; }
        }

        private string _referer;
        public string Referer
        {
            get { return this._referer; }
            set { this._referer = value; }
        }

        public string GetHtml(string url, Encoding encode, bool saveCookie)
        {
            HttpWebRequest hrq = WebRequest.Create(url) as HttpWebRequest;
            hrq.CookieContainer = this.CookieContainer;
            if (!string.IsNullOrEmpty(this.Referer))
            {
                hrq.Referer = this.Referer;
            }
            //hrq.Timeout = 5000;
            HttpWebResponse hrp = hrq.GetResponse() as HttpWebResponse;
            if (saveCookie)
            {
                this.CookieCollection = hrp.Cookies;
                this.CookieContainer.GetCookies(hrq.RequestUri);
            }
            this.Referer = string.Empty;
            using (StreamReader SR = new StreamReader(hrp.GetResponseStream(), encode))
            {
                return SR.ReadToEnd();
            }
        }
        public string PostHtml(string url, string postStr, Encoding encode, bool saveCookie)
        {

            HttpWebRequest hrq = WebRequest.Create(url) as HttpWebRequest;
            hrq.CookieContainer = this.CookieContainer;
            if (!string.IsNullOrEmpty(this.Referer))
            {
                hrq.Referer = this.Referer;
            }
            hrq.Method = "POST";
            hrq.ContentType = "application/x-www-form-urlencoded";
            hrq.UserAgent = "Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 6.1; WOW64; Trident/5.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E)";
            hrq.ProtocolVersion = HttpVersion.Version10; //这个东西貌似是默认1.1的，我这里设置的1.0,不知道有什么用，但是1.1有些地方经常报错

            byte[] myByte = encode.GetBytes(postStr);    //其实这里应该用encoding.default.getbytes(string),但是我一直这么用，貌似也没什么错...
            hrq.ContentLength = myByte.Length;
            using (Stream myStream = hrq.GetRequestStream())
            {
                myStream.Write(myByte, 0, myByte.Length);
            }

            HttpWebResponse hrp = hrq.GetResponse() as HttpWebResponse;
            if (saveCookie)
            {
                this.CookieCollection = hrp.Cookies;
                this.CookieContainer.GetCookies(hrq.RequestUri);
            }
            this.Referer = string.Empty;               
            using (StreamReader SR = new StreamReader(hrp.GetResponseStream(), encode))
            {
                return SR.ReadToEnd();
            }
        }       
    }
}
