﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading;
using System.Web;
using System.Windows;
using System.Windows.Forms;

namespace BdDemo
{
    class LoginHelp
    {
        /// <summary>
        /// 登陆百度的辅助类，我嫌太麻烦，给封装了一下
        /// </summary>
        public LoginHelp()
        {
            Thread td = new Thread(() =>
                {
                    if (!this.isReady())
                    {
                        MessageBox.Show("网络异常！请联网后重启程序");
                    }
                });
           
            td.IsBackground = true;
            td.Start();
        }

        private HttpHelp _hp = new HttpHelp();
        public HttpHelp HP
        {
            get { return this._hp; }
            set { this._hp = value; }
        }
        private string Token = string.Empty;

        /// <summary>
        /// 获取BAIDUID和Token，这个方法是在登陆辅助类初始化的时候就执行了
        /// </summary>
        /// <returns></returns>
        private bool isReady()                                             //这个是获取2个参数的，一个BAIDUID，一个Token，前者是cookie，后者是一个提交参数
        {
            try
            {
                this.HP = new HttpHelp();
                //拿到BAIDUID
                this.HP.GetHtml("http://www.baidu.com/", Encoding.UTF8, true);
                bool hasbaiduid = false;
                foreach (Cookie C in this.HP.CookieCollection)
                {
                    if (C.Name == "BAIDUID")
                    {
                        hasbaiduid = true;
                        break;
                    }
                }
                if (!hasbaiduid)         //检查是否获得BAIDUID
                {
                    return false;
                }
                //得到token
                string html = this.HP.GetHtml("https://passport.baidu.com/v2/api/?getapi&tpl=mn&apiver=v3&tt=1385512949190&class=login&logintype=dialogLogin&callback=bd__cbs__j3jwk9", Encoding.UTF8, true);
                //"token" : "0bc00c88798a46e75f644c2ea43d67a6"
                string pattern = "(?<=\"token\" : \")\\S+?(?=\")";
                this.Token = MatchHelp.GetString(html, pattern);
                if (!string.IsNullOrEmpty(this.Token))
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
            catch
            {
                return false;
            }
        }
        /// <summary>
        /// 验证码地址
        /// </summary>
        private string CodeStr = string.Empty;
        /// <summary>
        /// 检测到的用户名
        /// </summary>
        public string Name { get; set; }
        /// <summary>
        /// 登陆百度，成功返回"true"，失败"false"，如果需要验证码返回图片地址
        /// </summary>
        /// <param name="username"></param>
        /// <param name="password"></param>
        /// <param name="verifycode"></param>
        /// <returns></returns>
        public string Login(string username, string password, string verifycode) 
        {
            string poststr = string.Format("staticpage=http%3A%2F%2Fwww.baidu.com%2Fcache%2Fuser%2Fhtml%2Fv3Jump.html&charset=utf-8&token={0}&tpl=mn&apiver=v3&tt=1385516118111&codestring={1}&safeflg=0&u=http%3A%2F%2Fwww.baidu.com%2F&isPhone=false&quick_user=0&logintype=dialogLogin&splogin=newuser&username={2}&password={3}&verifycode={4}&mem_pass=on&ppui_logintime=96181&callback=parent.bd__pcbs__r03do0", this.Token, this.CodeStr, username, password, verifycode);

            string url = "https://passport.baidu.com/v2/api/?login";//用户名及密码提交地址 
            string html = this.HP.PostHtml(url, poststr, Encoding.UTF8, true);
            string pattern = "(?<=codeString=)[^&]+?(?=&)";
            this.CodeStr = MatchHelp.GetString(html, pattern);
            pattern = "(?<=userName=)[^&]*?(?=&)";
            this.Name = HttpUtility.UrlDecode(MatchHelp.GetString(html, pattern));
            if (!string.IsNullOrEmpty(this.CodeStr))
            {
                url = "https://passport.baidu.com/cgi-bin/genimage?" + this.CodeStr;
                return url;                                                                //返回验证码地址
            }
            else
            {
                Dictionary<string, string> myDict = new Dictionary<string, string>();
                myDict.Add("PTOKEN", string.Empty);
                myDict.Add("STOKEN", string.Empty);
                myDict.Add("SAVEUSERID", string.Empty);//这里还有一个cookie，我忘记名字了，不过这也将就了
                foreach (Cookie C in this.HP.CookieCollection)
                {
                    if (myDict.Keys.Contains(C.Name))
                    {
                        myDict[C.Name] = C.Value;
                    }
                }

                foreach (KeyValuePair<string, string> pair in myDict)
                {
                    if (string.IsNullOrEmpty(pair.Value))
                    {
                        return "false";
                    }
                }
                return "true";
            }
        }
    }
}
